/**
 * Copyright (c) 2015-present, Parse, LLC.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 *
 * 
 */

import ParseObject from './ParseObject';

export function makeParseInstallation(coreManager) {

  const instance = class extends Installation {
    constructor(attributes) {
      super(attributes, coreManager);
    }
  };

  coreManager.getObjectFacade().registerSubclass('_Installation', instance);

  return instance;
}

export default class Installation extends ParseObject {
  constructor(attributes, coreManager) {
    super('_Installation', undefined, undefined, coreManager);
    if (attributes && typeof attributes === 'object') {
      if (!this.set(attributes || {})) {
        throw new Error('Can\'t create an invalid Session');
      }
    }
  }
}